// Sharif Internet Contest 2008 (Nov 27 of 2008)
// A Soluton for Problem E (Empire of Extant AnacondaTigers)
// Author: Saeed Seddighin
#include <cstdio>
#include <iostream>

using namespace std;

const int MAX_N=1000000+200;

int n,size[MAX_N],par[MAX_N],m;

struct Edge{
  int x,y,cost;
  bool operator < (const Edge &s)const{
    if (cost != s.cost) return(cost < s.cost);
    if (x != s.x) return(x < s.x);
    return(y < s.y);
  }
}num[MAX_N];

int main(){
  int ttime;
  cin>>ttime;
  for (int ccount=1;ccount<=ttime;ccount++){
    cin>>n>>m;
    if (n > 50000 || m > 100000) cerr<<"Bad input"<<endl;
    for (int i=1;i<=m;i++){
      cin>>num[i].x>>num[i].y>>num[i].cost;
      if (num[i].x == num[i].y || num[i].x < 1 || num[i].y < 1 ||
          num[i].x > n || num[i].y > n || 
          num[i].cost < 0 || num[i].cost > 1000000)
        cerr<<"Bad Yal"<<endl;
    }
    sort(num+1,num+m+1);

    for (int i=1;i<=n;i++){
      size[i]=1;
      par[i]=0;
    }
    
    long long ans=0;
    int number=0;
    for (int i=1;i<=m;i++) if (number < n-2) {
      int a=num[i].x,b=num[i].y;
      while (par[a]) a=par[a];
      while (par[b]) b=par[b];
      if (a!=b){
        number++;
        ans+=num[i].cost;
        if (size[a] > size[b]) swap(a,b);
        par[a]=b;
        size[b]+=size[a];
        size[a]=0;
      }
    }
    if (number < n-2) cout<<-1<<endl;
    else cout<<ans<<endl;
  }
}
