// Sharif Internet Contest 2008 (Nov 27 of 2008)
// A Soluton for Problem C (CapsLock)
// Author: Saeed Seddighin
#include <cstdio>
#include <iostream>
#include <sstream>
#define int long long

using namespace std;

const int P=30269;

stringstream tin;

int Mod(int s){
  return((P+s%P)%P);
}

int Pow(int s,int t){
  if (!t) return(1);
  int ans=Pow(s,t/2);
  ans=Mod(ans*ans);
  if (t%2) ans=Mod(ans*s);
  return(ans);
}

int Div(int s,int t){ 
  return(Mod(s*Pow(t,P-2)));
}

int findVal(){
  char temp;
  tin>>temp;
  if (temp != '*' && temp!='+' && temp!='/' && temp!='-' && temp!='^'){
    tin.putback(temp);
    int a;
    tin>>a;
    return(a);
  }
  int first=findVal();
  int sec=findVal();
  if (temp == '*') return(Mod(first*sec));
  if (temp == '-') return(Mod(first-sec));
  if (temp == '+') return(Mod(first+sec));
  if (temp == '^') return(Pow(first,sec));
  if (temp == '/') return(Div(first,sec));
}

int cal(string s){
  tin.clear();
  tin<<s;
  return(findVal());
}

main(){
  string temp="";
  int ttime;
  cin>>ttime;
  for (int ccount=1;ccount<=ttime;ccount++){
    temp="";
    while (temp=="") getline(cin,temp);
    int a=cal(temp);
    if (a > P/2) cout<<-(P-a)<<endl;
    else cout<<a<<endl;
  }
}
