// Sharif Internet Contest 2008 (Nov 27 of 2008)
// A Soluton for Problem B (Bold, Italic, Underline)
// Author: Aideen NasiriShargh
#include <vector>
#include <cctype>
#include <iostream>
#include <string>
#include <cassert>
#define FOR(i,x,n) for (__typeof(x) i = (x); i != (n); i++)
#define FR(i,n) FOR(i,0,n)
#define FRI(it,v) FOR(it,v.begin(),v.end())
#define SZ size()
#define show(x) cerr << #x << "=" << x << endl;
#define CLR(a,v) memset(a, v, sizeof a);
using namespace std;

const int MAX_LEN = 1000 + 13;
int match[MAX_LEN];
vector<int> v;
string s; // IBU
string att[3] = {"font-style: italic;", "font-weight: bold;", "text-decoration: underline;"};
string ES = "</span>";
string BS = "<span style=\"";

#define D 0

string write(string s) {
  if (D) cerr << "RETURNED: " << s << endl;
  return s;
}

string solve(int l, int r, int mask = 0) {
  string tmp = s.substr(l, r-l);
  int start = tmp.find("<");
  int finish = tmp.rfind(">");

  if (D) cerr << "calling: " << tmp << "[" << mask << "] " << "(" << l << ","<<r<<") " << start << " " << finish << endl;

  if (start == 0 && finish+1 == r-l && match[l+1] == r-2) {
    if (D) cerr << "!!!" << endl;
    int w = string("ibu").find(s[l+1]);
    assert(w != (int)s.npos);
    return write(solve(l+3, r-4, mask |= (1 << w)));
  }

  string ret ="", retend="";
  if (mask != 0) {
    ret = BS;
    int nofirst = 0;
    FR(i,3)
      if ((mask >> i) & 1) {
	if (nofirst++) ret += " ";
		ret += att[i];
    }
    ret += "\">";
    retend = ES;
  }	

  if (start == (int)tmp.npos) 
    return write(ret+tmp+retend);
  start += l; finish += l + 1;

  if (start != l || finish != r) // aaa<...>bbb
    return write(ret+s.substr(l, start-l) + solve(start,finish) + s.substr(finish, r-finish)+retend);

  if (match[start+1] != finish-2)
    return write(ret+solve(start,match[start+1]+2)+solve(match[start+1]+2,finish)+retend);
	
  assert(1); return "";
}

int main() {
  int testn;
  for (cin >> testn; testn--;) {
    cin >> s;
    if (D) show(s);
    CLR(match, -1);
    
    FR(i,(int)s.length()) 
      if (s[i] == '<')
	if (s[i+1] == '/') {
	  match[v.back()] = i+2;
	  match[i+2] = v.back();
	  v.pop_back();
	}
	else 
	  v.push_back(i+1);
    
    cout << solve(0, s.SZ) << endl;
  }
  return 0;
}
